namespace ScrewsMaster
{
    public class OpenGameUICtrl : BaseUICtrl
    {
        private OpenGameUI ui;
        private OpenGameModel model;

        private uint openUIMsg = UICtrlMsg.OpenGameUI_Open;
        private uint closeUIMsg = UICtrlMsg.OpenGameUI_Close;

        #region 生命周期
        protected override void OnInit()
        {
            //model = ModuleManager.Instance.GetModel(ModelConst.OpenGameModel) as OpenGameModel;
        }

        protected override void OnDispose()
        {
        }

        public override void OpenUI(object args = null)
        {
            if (ui == null)
            {
                ui = new OpenGameUI(this);
                ui.Open(args);
            }
        }

        public override void CloseUI(object args = null)
        {
            if (ui != null && !ui.isClose)
            {
                ui.Close();
            }
            ui = null;
        }
        public void PlayAnim(object args = null)
        {
            if (ui != null && !ui.isClose)
            {
                ui.PlayAnim();
            }
        }
        #endregion

        #region 消息
        public override uint GetOpenUIMsg(string uiName)
        {
            return openUIMsg;
        }
        public override uint GetCloseUIMsg(string uiName)
        {
            return closeUIMsg;
        }

        protected override void AddListener()
        {
            uiCtrlDispatcher.AddListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.AddListener(closeUIMsg, CloseUI);
            uiCtrlDispatcher.AddListener(UICtrlMsg.OpenGameUI_PlayAnim, PlayAnim);
        }
        protected override void RemoveListener()
        {
            uiCtrlDispatcher.RemoveListener(openUIMsg, OpenUI);
            uiCtrlDispatcher.RemoveListener(closeUIMsg, CloseUI);
            uiCtrlDispatcher.RemoveListener(UICtrlMsg.OpenGameUI_PlayAnim, PlayAnim);
        }

        protected override void AddServerListener()
        {

        }
        protected override void RemoveServerListener()
        {

        }
        #endregion
    }
}